
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/accessible.hh>
%}
%define alg_accessible_interface(Automaton, GenAutomaton, Series, Exp, HList)
static HList accessible_states(const Automaton& a) ;
static HList accessible_states(const GenAutomaton& a) ;
static Automaton accessible(const Automaton& a) ;
static GenAutomaton accessible(const GenAutomaton& a) ;
static void accessible_here(Automaton& a) ;
static void accessible_here(GenAutomaton& a) ;
static HList coaccessible_states(const Automaton& a) ;
static HList coaccessible_states(const GenAutomaton& a) ;
static Automaton coaccessible(const Automaton& a) ;
static GenAutomaton coaccessible(const GenAutomaton& a) ;
static void coaccessible_here(Automaton& a) ;
static void coaccessible_here(GenAutomaton& a) ;
%enddef
%define alg_accessible_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  HList accessible_states(const Automaton& a) { return list_of_set(vcsn::accessible_states(*a)); }
static  HList accessible_states(const GenAutomaton& a) { return list_of_set(vcsn::accessible_states(*a)); }
static  Automaton accessible(const Automaton& a) { return vcsn::accessible(*a); }
static  GenAutomaton accessible(const GenAutomaton& a) { return vcsn::accessible(*a); }
static  void accessible_here(Automaton& a) { return vcsn::accessible_here(*a); }
static  void accessible_here(GenAutomaton& a) { return vcsn::accessible_here(*a); }
static  HList coaccessible_states(const Automaton& a) { return list_of_set(vcsn::coaccessible_states(*a)); }
static  HList coaccessible_states(const GenAutomaton& a) { return list_of_set(vcsn::coaccessible_states(*a)); }
static  Automaton coaccessible(const Automaton& a) { return vcsn::coaccessible(*a); }
static  GenAutomaton coaccessible(const GenAutomaton& a) { return vcsn::coaccessible(*a); }
static  void coaccessible_here(Automaton& a) { return vcsn::coaccessible_here(*a); }
static  void coaccessible_here(GenAutomaton& a) { return vcsn::coaccessible_here(*a); }
%enddef
%define alg_interface_accessible(Kind)
%{
struct Kind ##_alg_accessible {
alg_accessible_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_accessible(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_accessible {
alg_accessible_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_accessible {
alg_accessible_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
