
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/backward_closure.hh>
%}
%define alg_backward_closure_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void backward_closure_here(Automaton& a) ;
static void backward_closure_here(GenAutomaton& a) ;
static Automaton backward_closure(const Automaton& a) ;
static GenAutomaton backward_closure(const GenAutomaton& a) ;
%enddef
%define alg_backward_closure_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void backward_closure_here(Automaton& a) { return vcsn::backward_closure_here(*a); }
static  void backward_closure_here(GenAutomaton& a) { return vcsn::backward_closure_here(*a); }
static  Automaton backward_closure(const Automaton& a) { return vcsn::backward_closure(*a); }
static  GenAutomaton backward_closure(const GenAutomaton& a) { return vcsn::backward_closure(*a); }
%enddef
%define alg_interface_backward_closure(Kind)
%{
struct Kind ##_alg_backward_closure {
alg_backward_closure_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_backward_closure(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_backward_closure {
alg_backward_closure_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_backward_closure {
alg_backward_closure_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
