
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/concatenate.hh>
%}
%define alg_concatenate_interface(Automaton, GenAutomaton, Series, Exp, HList)
static Automaton concatenate(const Automaton& a1, const Automaton& a2) ;
static GenAutomaton concatenate(const GenAutomaton& a1, const GenAutomaton& a2) ;
static void concatenate_here(Automaton& a1, const Automaton& a2) ;
static void concatenate_here(GenAutomaton& a1, const GenAutomaton& a2) ;
%enddef
%define alg_concatenate_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  Automaton concatenate(const Automaton& a1, const Automaton& a2) { return vcsn::concatenate(*a1, *a2); }
static  GenAutomaton concatenate(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::concatenate(*a1, *a2); }
static  void concatenate_here(Automaton& a1, const Automaton& a2) { return vcsn::concatenate_here(*a1, *a2); }
static  void concatenate_here(GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::concatenate_here(*a1, *a2); }
%enddef
%define alg_interface_concatenate(Kind)
%{
struct Kind ##_alg_concatenate {
alg_concatenate_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_concatenate(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_concatenate {
alg_concatenate_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_concatenate {
alg_concatenate_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
