
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/determinize.hh>
%}
%define alg_determinize_interface(Automaton, GenAutomaton, Series, Exp, HList)
static Automaton determinize(const Automaton& a) ;
static bool is_deterministic(const Automaton& a) ;
%enddef
%define alg_determinize_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  Automaton determinize(const Automaton& a) { return vcsn::determinize(*a); }
static  bool is_deterministic(const Automaton& a) { return vcsn::is_deterministic(*a); }
%enddef
%define alg_interface_determinize(Kind)
%{
struct Kind ##_alg_determinize {
alg_determinize_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_determinize(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_determinize {
alg_determinize_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_determinize {
alg_determinize_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
