
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/eval.hh>
%}
%define alg_eval_interface(Automaton, GenAutomaton, Series, Exp, HList)
static int eval(const Automaton& a, const std::string& s) ;
static int eval(const GenAutomaton& a, const std::string& s) ;
%enddef
%define alg_eval_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  int eval(const Automaton& a, const std::string& s) { return vcsn::eval(*a, Series::monoid_elt_t((*a).set().series().monoid(), s)).value(); }
static  int eval(const GenAutomaton& a, const std::string& s) { return vcsn::eval(*a, Series::monoid_elt_t((*a).set().series().monoid(), s)).value(); }
%enddef
%define alg_interface_eval(Kind)
%{
struct Kind ##_alg_eval {
alg_eval_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_eval(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_eval {
alg_eval_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_eval {
alg_eval_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
