
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/forward_closure.hh>
%}
%define alg_forward_closure_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void forward_closure_here(Automaton& a) ;
static void forward_closure_here(GenAutomaton& a) ;
static Automaton forward_closure(const Automaton& a) ;
static GenAutomaton forward_closure(const GenAutomaton& a) ;
%enddef
%define alg_forward_closure_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void forward_closure_here(Automaton& a) { return vcsn::forward_closure_here(*a); }
static  void forward_closure_here(GenAutomaton& a) { return vcsn::forward_closure_here(*a); }
static  Automaton forward_closure(const Automaton& a) { return vcsn::forward_closure(*a); }
static  GenAutomaton forward_closure(const GenAutomaton& a) { return vcsn::forward_closure(*a); }
%enddef
%define alg_interface_forward_closure(Kind)
%{
struct Kind ##_alg_forward_closure {
alg_forward_closure_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_forward_closure(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_forward_closure {
alg_forward_closure_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_forward_closure {
alg_forward_closure_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
