
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/krat_exp_cderivation.hh>
%}
%define alg_krat_exp_cderivation_interface(Automaton, GenAutomaton, Series, Exp, HList)
static Exp cderivate(const Exp& e, char l) ;
static Exp cderivate(const Exp& e, const std::string& w) ;
%enddef
%define alg_krat_exp_cderivation_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  Exp cderivate(const Exp& e, char l) { return vcsn::cderivate(e, l); }
static  Exp cderivate(const Exp& e, const std::string& w) { return vcsn::word_cderivate(e, Series::monoid_elt_t(e.set().monoid(), w)); }
%enddef
%define alg_interface_krat_exp_cderivation(Kind)
%{
struct Kind ##_alg_krat_exp_cderivation {
alg_krat_exp_cderivation_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_krat_exp_cderivation(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_krat_exp_cderivation {
alg_krat_exp_cderivation_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_krat_exp_cderivation {
alg_krat_exp_cderivation_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
