
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/standard.hh>
%}
%define alg_standard_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void standardize(Automaton& a) ;
static void standardize(GenAutomaton& a) ;
static bool is_standard(Automaton& a) ;
static bool is_standard(GenAutomaton& a) ;
static void union_of_standard_here(Automaton& a1, const Automaton& a2) ;
static void union_of_standard_here(GenAutomaton& a1, const GenAutomaton& a2) ;
static Automaton union_of_standard(const Automaton& a1, const Automaton& a2) ;
static GenAutomaton union_of_standard(const GenAutomaton& a1, const GenAutomaton& a2) ;
static void concat_of_standard_here(Automaton& a1, const Automaton& a2) ;
static void concat_of_standard_here(GenAutomaton& a1, const GenAutomaton& a2) ;
static Automaton concat_of_standard(const Automaton& a1, const Automaton& a2) ;
static GenAutomaton concat_of_standard(const GenAutomaton& a1, const GenAutomaton& a2) ;
static void star_of_standard_here(Automaton& a) ;
static void star_of_standard_here(GenAutomaton& a) ;
static Automaton star_of_standard(const Automaton& a) ;
static GenAutomaton star_of_standard(const GenAutomaton& a) ;
%enddef
%define alg_standard_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void standardize(Automaton& a) { return vcsn::standardize(*a); }
static  void standardize(GenAutomaton& a) { return vcsn::standardize(*a); }
static  bool is_standard(Automaton& a) { return vcsn::is_standard(*a); }
static  bool is_standard(GenAutomaton& a) { return vcsn::is_standard(*a); }
static  void union_of_standard_here(Automaton& a1, const Automaton& a2) { return vcsn::union_of_standard_here(*a1, *a2); }
static  void union_of_standard_here(GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::union_of_standard_here(*a1, *a2); }
static  Automaton union_of_standard(const Automaton& a1, const Automaton& a2) { return vcsn::union_of_standard(*a1, *a2); }
static  GenAutomaton union_of_standard(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::union_of_standard(*a1, *a2); }
static  void concat_of_standard_here(Automaton& a1, const Automaton& a2) { return vcsn::concat_of_standard_here(*a1, *a2); }
static  void concat_of_standard_here(GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::concat_of_standard_here(*a1, *a2); }
static  Automaton concat_of_standard(const Automaton& a1, const Automaton& a2) { return vcsn::concat_of_standard(*a1, *a2); }
static  GenAutomaton concat_of_standard(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::concat_of_standard(*a1, *a2); }
static  void star_of_standard_here(Automaton& a) { return vcsn::star_of_standard_here(*a); }
static  void star_of_standard_here(GenAutomaton& a) { return vcsn::star_of_standard_here(*a); }
static  Automaton star_of_standard(const Automaton& a) { return vcsn::star_of_standard(*a); }
static  GenAutomaton star_of_standard(const GenAutomaton& a) { return vcsn::star_of_standard(*a); }
%enddef
%define alg_interface_standard(Kind)
%{
struct Kind ##_alg_standard {
alg_standard_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_standard(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_standard {
alg_standard_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_standard {
alg_standard_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
