
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/transpose.hh>
%}
%define alg_transpose_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void transpose(Automaton& dst, const Automaton& src) ;
static void transpose(GenAutomaton& dst, const GenAutomaton& src) ;
static Automaton transpose(const Automaton& a) ;
static GenAutomaton transpose(const GenAutomaton& a) ;
%enddef
%define alg_transpose_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void transpose(Automaton& dst, const Automaton& src) { vcsn::transpose(*dst, *src); }
static  void transpose(GenAutomaton& dst, const GenAutomaton& src) { vcsn::transpose(*dst, *src); }
static  Automaton transpose(const Automaton& a) { return vcsn::transpose(*a); }
static  GenAutomaton transpose(const GenAutomaton& a) { return vcsn::transpose(*a); }
%enddef
%define alg_interface_transpose(Kind)
%{
struct Kind ##_alg_transpose {
alg_transpose_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_transpose(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_transpose {
alg_transpose_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_transpose {
alg_transpose_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
